import { DomSanitizer } from '@angular/platform-browser';
import { BreakpointObserver, Breakpoints } from '@angular/cdk/layout';
import { Injectable, NgModule, Component, Input, Output, EventEmitter, defineInjectable } from '@angular/core';
import { CommonModule } from '@angular/common';
import { BrowserAnimationsModule, NoopAnimationsModule } from '@angular/platform-browser/animations';
import 'hammerjs';
import { DragDropModule } from '@angular/cdk/drag-drop';
import { MatTooltipModule } from '@angular/material';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularDraggableWidgetService = /** @class */ (function () {
    function AngularDraggableWidgetService() {
    }
    AngularDraggableWidgetService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AngularDraggableWidgetService.ctorParameters = function () { return []; };
    /** @nocollapse */ AngularDraggableWidgetService.ngInjectableDef = defineInjectable({ factory: function AngularDraggableWidgetService_Factory() { return new AngularDraggableWidgetService(); }, token: AngularDraggableWidgetService, providedIn: "root" });
    return AngularDraggableWidgetService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularDraggableWidgetComponent = /** @class */ (function () {
    function AngularDraggableWidgetComponent(breakpointObserver, sanitizer) {
        var _this = this;
        this.sanitizer = sanitizer;
        this.onOpen = new EventEmitter();
        this.onClose = new EventEmitter();
        this.onMinimize = new EventEmitter();
        this.onDragStart = new EventEmitter();
        this.onDragEnd = new EventEmitter();
        this.onDragMoved = new EventEmitter();
        this.onDragReleased = new EventEmitter();
        this.onWidgetDClicked = new EventEmitter();
        this.isOpened = false;
        this.isDraggable = true;
        this.isMinimizable = true;
        this.title = "Title";
        this.isMinimized = false;
        this.isSmallScreen = false;
        breakpointObserver.observe([
            '(max-width: 600px)',
            Breakpoints.XSmall,
            Breakpoints.Web
        ]).subscribe((/**
         * @param {?} result
         * @return {?}
         */
        function (result) {
            if (result.matches) {
                if (result.breakpoints['(max-width: 600px)']) {
                    _this.isSmallScreen = true;
                }
                else
                    _this.isSmallScreen = false;
            }
        }));
    }
    /**
     * @return {?}
     */
    AngularDraggableWidgetComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        // this.isOpened = this.isOpened == true ? true : false,
        //   this.isDraggable = this.isDraggable == true ? true : false,
        //   // isOpened: (this.config.isOpened == true || this.config.isOpened == undefined) ? true : false,
        //   title: this.config.title || "Title",
        //   isMinimizable: (this.config.isMinimizable == true || this.config.isMinimizable == undefined) ? true : false
        // });
        this.safeIconImageSrc = this.iconImageSrc && this.sanitizer.bypassSecurityTrustResourceUrl(this.iconImageSrc);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    AngularDraggableWidgetComponent.prototype.ngOnChanges = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (event.isOpened) {
            /** @type {?} */
            var widgets = document.getElementsByClassName("widget");
            if (event.isOpened.currentValue == true) {
                this.zIndex = this.zIndex || widgets.length;
                this.yPosition = this.yPosition || Math.floor(Math.random() * 40) + 20 + "%";
                this.xPosition = this.xPosition || Math.floor(Math.random() * 30) + 15 + "%";
                this.onOpen.emit(event.isOpened.currentValue);
            }
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    AngularDraggableWidgetComponent.prototype.dragStart = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.onDragStart.emit(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    AngularDraggableWidgetComponent.prototype.dragEnd = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.onDragEnd.emit(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    AngularDraggableWidgetComponent.prototype.dragMoved = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.onDragMoved.emit(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    AngularDraggableWidgetComponent.prototype.widgetDClicked = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.isMinimized = !this.isMinimized;
        this.onWidgetDClicked.emit(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    AngularDraggableWidgetComponent.prototype.dragReleased = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.onDragReleased.emit(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    AngularDraggableWidgetComponent.prototype.close = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.isOpened = false;
        this.onClose.emit(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    AngularDraggableWidgetComponent.prototype.widgetMinimized = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.isMinimized = !this.isMinimized;
        this.onMinimize.emit(event);
    };
    AngularDraggableWidgetComponent.decorators = [
        { type: Component, args: [{
                    selector: 'draggable-widget',
                    template: "<div class=\"widget\" cdkDrag [class.widgetMinimized]=\"isMinimized && !isSmallScreen\" *ngIf=\"isOpened\"\r\n    [style.top]=\"xPosition\" [style.left]=\"yPosition\" [style.z-index]=\"zIndex\"\r\n    [cdkDragDisabled]=\"isSmallScreen || !isDraggable\" (cdkDragStarted)=\"dragStart($event)\"\r\n    (cdkDragEnded)=\"dragEnd($event)\" (cdkDragReleased)=\"dragReleased($event)\" (cdkDragMoved)=\"dragMoved($event)\">\r\n\r\n    <div *ngIf=\"isMinimized && !isSmallScreen\" class=\"widgetAsIcon\" (dblclick)=\"widgetDClicked($event)\">\r\n        <img *ngIf=\"!!iconImageSrc\" [src]=\"safeIconImageSrc\">\r\n        <div *ngIf=\"!(!!iconImageSrc)\">{{title}}</div>\r\n    </div>\r\n\r\n    <div *ngIf=\"!isMinimized || isSmallScreen\">\r\n        <div class=\"header\" cdkDragHandle>\r\n            <img *ngIf=\"!!iconImageSrc\" class=\"image\" [src]=\"safeIconImageSrc\">\r\n\r\n            <div class=\"title\" style.left=\"{{!(!!iconImageSrc) && '5px'}}\">{{title}}</div>\r\n\r\n            <div class=\"iconsContainer\">\r\n                <i *ngIf=\"isMinimizable\" class=\"material-icons headerIcon\" (click)=\"widgetMinimized($event)\"\r\n                    matTooltip=\"{{ isMinimized ? 'maximize'  : 'minimize'}}\">\r\n                    {{isMinimized ? 'add' : 'remove'}}\r\n                </i>\r\n\r\n                <i class=\"material-icons headerIcon\" (click)=\"close($event)\" matTooltip=\"close\">\r\n                    cancel\r\n                </i>\r\n            </div>\r\n        </div>\r\n\r\n        <div class=\"content\" *ngIf=\"!isMinimized\">\r\n            <ng-content></ng-content>\r\n        </div>\r\n    </div>\r\n\r\n</div>",
                    styles: [".widget{border-radius:5px;position:fixed;transition:box-shadow .2s cubic-bezier(0,0,.2,1);box-shadow:0 3px 1px -2px rgba(0,0,0,.2),0 2px 2px 0 rgba(0,0,0,.14),0 1px 5px 0 rgba(0,0,0,.12);background-color:rgba(255,255,255,.9);width:auto;height:auto;min-width:300px;max-width:400px}.widget:active{box-shadow:0 5px 5px -3px rgba(0,0,0,.2),0 8px 10px 1px rgba(0,0,0,.14),0 3px 14px 2px rgba(0,0,0,.12);opacity:1;z-index:10}.header:active{box-shadow:0 5px 5px -3px rgba(0,0,0,.2),0 8px 10px 1px rgba(0,0,0,.14),0 3px 14px 2px rgba(0,0,0,.12);opacity:.7}.header{position:relative;top:0;cursor:move;height:2em;width:100%;background-color:grey}.title{color:#fff;font-weight:700;position:absolute;top:25%;left:32px}.iconsContainer{float:right}.content{padding:15px}.headerIcon{cursor:pointer;color:#fffF;margin:3px}.image{width:25px;height:25px;border-radius:50%;float:left;position:relative;margin:3px 0 0 2px}.widgetMinimized{min-height:auto;cursor:pointer;width:40px;height:40px;overflow:hidden;min-width:auto;border-radius:50%;box-shadow:0 20px 20px -3px rgba(0,0,0,.2),0 8px 10px 1px rgba(0,0,255,.3),0 3px 14px 2px rgba(0,0,0,.5)}.widgetAsIcon{width:100%;height:100%;display:block;text-align:center;font-size:.65rem;position:absolute;left:50%;top:50%;-webkit-transform:translate(-50%,-50%);transform:translate(-50%,-50%)}.widgetAsIcon>*{position:inherit;left:50%;top:50%;-webkit-transform:translate(-50%,-50%);transform:translate(-50%,-50%)}.widgetAsIcon>img{position:inherit;width:25px;height:25px;left:50%;top:50%;-webkit-transform:translate(-50%,-50%);transform:translate(-50%,-50%)}@font-face{font-family:'Material Icons';font-style:normal;font-weight:400;src:url(https://fonts.gstatic.com/s/materialicons/v47/flUhRq6tzZclQEJ-Vdg-IuiaDsNc.woff2) format('woff2')}.material-icons{font-family:'Material Icons';font-weight:400;font-style:normal;font-size:24px;line-height:1;letter-spacing:normal;text-transform:none;display:inline-block;white-space:nowrap;word-wrap:normal;direction:ltr;-webkit-font-feature-settings:'liga';-webkit-font-smoothing:antialiased}@media only screen and (max-width:600px){.widget{-webkit-transform:none;transform:none;bottom:0;top:auto!important;max-width:600px;width:100%;left:0!important}.header{cursor:auto!important}}"]
                }] }
    ];
    /** @nocollapse */
    AngularDraggableWidgetComponent.ctorParameters = function () { return [
        { type: BreakpointObserver },
        { type: DomSanitizer }
    ]; };
    AngularDraggableWidgetComponent.propDecorators = {
        onOpen: [{ type: Output }],
        onClose: [{ type: Output }],
        onMinimize: [{ type: Output }],
        onDragStart: [{ type: Output }],
        onDragEnd: [{ type: Output }],
        onDragMoved: [{ type: Output }],
        onDragReleased: [{ type: Output }],
        onWidgetDClicked: [{ type: Output }],
        isOpened: [{ type: Input }],
        isDraggable: [{ type: Input }],
        isMinimizable: [{ type: Input }],
        title: [{ type: Input }],
        xPosition: [{ type: Input }],
        yPosition: [{ type: Input }],
        zIndex: [{ type: Input }],
        iconImageSrc: [{ type: Input }]
    };
    return AngularDraggableWidgetComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularDraggableWidgetModule = /** @class */ (function () {
    function AngularDraggableWidgetModule() {
    }
    AngularDraggableWidgetModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [AngularDraggableWidgetComponent],
                    imports: [
                        BrowserAnimationsModule,
                        NoopAnimationsModule,
                        DragDropModule,
                        CommonModule,
                        MatTooltipModule
                    ],
                    exports: [AngularDraggableWidgetComponent]
                },] }
    ];
    return AngularDraggableWidgetModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AngularDraggableWidgetService, AngularDraggableWidgetComponent, AngularDraggableWidgetModule };

//# sourceMappingURL=angular-draggable-widget.js.map